#if !defined(CKOMA_H)
#define CKOMA_H

// koma.h : CKoma NX̐錾уC^[tFCX̒`܂B
//
/////////////////////////////////////////////////////////////////////////////
#define	KOMA_ENABLE		(WORD)8
#define	KOMA_SIDE		(WORD)16
#define	KOMA_NARI		(WORD)32
#define	KOMA_ACTIVE		(WORD)64
#define	KOMA_CANGROW	(WORD)128

#define HBYTE(a)		(((BYTE)(a))&0xF)
#define SGC_X(a)		(((WORD)(a) >> 12) & 0xF)
#define SGC_Y(a)		(((WORD)(a) >> 8) & 0xF)
#define SGC_ST(a)		(((WORD)(a) >> 4) & 0xF)
#define SGC_ID(a)		((a) & 0x7)
#define	SENTE	1
#define	GOTE	0

// ret code of CKoma::Move()
#define MV_OK			1	// 
#define	MV_OUTOFBAN		-1	// ՊOł
#define MV_NOTCHANGE	-2	// ̈ʒuςȂ
#define MV_SAMESIDE		-3	// w̋
#define	MV_NIFU			-4	// 
#define	MV_CANNOTDROP	-5	// ՏɗƂȂ
#define	MV_CANNOTMOVE	-6	// ŗL̓Ŏs
#define MV_DISABLE		-7	// Cl[ułȂ

#define NR_NO		0
#define NR_ABLE		1
#define NR_MUST		2

#define	OTI_KYOSYA		1
#define	OTI_KAKU		2
#define	OTI_HISYA		3
#define	OTI_HISYAKYO	4
#define	OTI_2MAI		5
#define	OTI_4MAI		6
#define	OTI_6MAI		7

enum	KOMAID { GYOKU = 0, HISYA, KAKU, KIN, GIN, KEIMA, KYOSYA, FU };	

// -- version 2.8 ̎dlɂԍςĂ͂
enum{	KOMA_LASTMOVED = 40,	// moveO񓮂
		KOMA_USER = 41,				// RɎgpĂ悢
		KOMA_LASTMOVED_FROM = 42,
		KOMA_GAME_START = 43,
		KOMA_SENTE_TORYO = 44,
		KOMA_GOTE_TORYO = 45,
		KOMA_SENTE_SYORI = 46,
		KOMA_GOTE_SYORI = 47,
		KOMA_SENTE_TIMEOUT = 48,
		KOMA_GOTE_TIMEOUT = 49
		};	// LASTMOVEDMOVEȌ

/*****************
<HIBYTE>	<LOBITE>
7---------	7 CanGrow
6 point.x	6 Active
5 0->8		5 Nari
4---------	4 Side
3---------	3 Enable
2 point.y	2---------
1 0->8		1 KOMAID
0---------	0---------
*****************/

/////////////////////////////////////////////////////////////////////////////
// Class Ckoma

class	CKoma : public CObject
{
protected:
	DECLARE_DYNCREATE(CKoma)

public:
	int		m_nOti;

private : // register
	WORD	m_wStatus[64];
private : // func


public :
	void GetTeaiString(CString& csTeaiStr);
	WORD	m_nLastMovedNo;
	int GetGyokuNo(int nSide);
	BOOL IsBeDead(int no);
	void ReverseAllFlags();
	void Init();
	CKoma();

	virtual		~CKoma(){};
	virtual void Serialize(CArchive& ar);   // overridden for document i/o

	int		CheckNariFlag(int no, CPoint cpDest);
	int		SerchKomaByPoint( CPoint cp );
	int		SerchKomaByPoint( int x, int y );
	BOOL	CheckMovePoint( int no );
	BOOL	CheckMovePoint( int no, CPoint cpDest );
	CPoint	SetPoint( int no, CPoint cpDst );
	CPoint	SetPoint( int no, int dstx, int dsty );

	////////////////////////////////////
	//	Set
	// no ̑傫`FbN͂Ȃ̂Œ

	WORD	SetWord( int no, WORD w );
	BOOL	Move( int no, CPoint cpDst, BOOL bMove = TRUE );
	BOOL	SetID( int no, KOMAID kid );
	BOOL	SetSide( int no, BOOL bSide  = SENTE );
	BOOL	ChangeSide( int no );
	BOOL	SetNari( int no, BOOL b = TRUE /* Be Nari */ );
	BOOL	SetActive( int no, BOOL b = TRUE /* Be Active */ );
	BOOL	SetEnable( int no, BOOL b = TRUE );
	BOOL	SetStatus( int no, KOMAID kid, CPoint cp, BOOL bSide = SENTE, BOOL nari = FALSE,BOOL bActive = TRUE, BOOL bEnable = TRUE );
	CPoint	ReversePoint( int id );
	void	ReverseAll();

	////////////////////////////////////
	//	Get (inline)
	WORD	GetWord( int no ) { return m_wStatus[no]; }
	KOMAID	GetID( int no ){ return (KOMAID)SGC_ID( m_wStatus[no] );	}
	CPoint	GetPoint( int no ){	return CPoint((LONG)SGC_X(m_wStatus[no]),(LONG)SGC_Y(m_wStatus[no])); }
	BOOL	GetSide( int no ){ return ((m_wStatus[no] & KOMA_SIDE)!=0); }
	BOOL	IsNari( int no ){ return ((m_wStatus[no] & KOMA_NARI)!=0); }
	BOOL	IsActive( int no ){	return ((m_wStatus[no] & KOMA_ACTIVE)!=0); }
	BOOL	IsGrow( int no ){return ((m_wStatus[no]&KOMA_CANGROW)!=0); }
	BOOL	IsEnable( int no ){return((m_wStatus[no]&KOMA_ENABLE)!=0); }
	CString	GetName( int no );
};

#endif //CKOMA_H
