#include "stdafx.h"
#include "msg.h"
#include "nshogi2.h"
#include "NSDoc.h"
#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsg

IMPLEMENT_DYNCREATE(CMsg, CObject)

/////////////////////////////////////////////////////////////////////////////
// CMsg construction/destruction

CMsg::CMsg()
{
}

CMsg::CMsg(CNSDoc* pDoc)
{
	m_pDoc = pDoc;
}

CMsg::~CMsg()
{
}

/////////////////////////////////////////////////////////////////////////////
// CMsg Operations


/////////////////////////////////////////////////////////////////////////////
// CMsg serialization

void CMsg::Serialize(CArchive& ar)
{

	if (ar.IsStoring())
	{
		WriteMsg(ar);
	}
	else
	{
		ReadMsg(ar);
	}
}

void CMsg::WriteMsg(CArchive& ar)
{
	// R}h̑M
	ar << m_dwCmd;

	// ǉ̃f[^M
	switch( m_dwCmd )
	{
		case MSG_BTL_NEW_SENTE:
		case MSG_BTL_NEW_GOTE:
		{
			ar << m_pDoc->m_nSenteTime;
			ar << m_pDoc->m_nGoteTime;
			ar << m_pDoc->m_nDefaultCounter;
			ar << m_pDoc->m_bCountUp;
		}
		case MSG_DATA:			// f[^M
		case MSG_GAME_END:
		{
			ar << (DWORD)m_pDoc->m_pKifu->GetTail();
			ar << m_pDoc->m_nSenteTime;
			ar << m_pDoc->m_nGoteTime;
			break;
		}
		
		case MSG_KIFUDATA:		// SđM
		{
			m_pDoc->m_koma.Serialize(ar);
			ar << m_pDoc->m_pKifu->GetCount();
			for( POSITION pos = (m_pDoc->m_pKifu)->GetHeadPosition(); pos != NULL;)
			{
				// Doc̊Xgf[^
				ar << (DWORD)((m_pDoc->m_pKifu)->GetNext( pos ));
			}
			ar << ((CNShogiApp*)AfxGetApp())->m_rgst.m_szMyName;
			break;
		}

		case MSG_CONNECT:
		case MSG_GALLARY_CONNECT:
		{
			ar << ((CNShogiApp*)AfxGetApp())->m_rgst.m_szMyName;
			break;
		}
		case MSG_MAIL:
		{
			ar << m_pDoc->m_szMailString;
			break;
		}

		case MSG_GALLARY_KIFUDATA:
		{
			m_pDoc->m_koma.Serialize(ar);
			ar << m_pDoc->m_pKifu->GetCount();
			for( POSITION pos = (m_pDoc->m_pKifu)->GetHeadPosition(); pos != NULL;)
			{
				// Doc̊Xgf[^
				ar << (DWORD)((m_pDoc->m_pKifu)->GetNext( pos ));
			}
			ar << m_pDoc->m_szSenteName;
			ar << m_pDoc->m_szGoteName;
			break;
		}

		case MSG_GALLARY_DATA:
		{
			ar << (DWORD)m_pDoc->m_pKifu->GetTail();
			break;
		}
		// `̃bZ[WR}h
		default:
		{
			break;
		}
	}
}
void CMsg::ReadMsg(CArchive& ar)
{
	ar >> m_dwCmd;

	switch( m_dwCmd )
	{
		case MSG_BTL_NEW_SENTE:
		case MSG_BTL_NEW_GOTE:
		{
			ar >> m_pDoc->m_nSenteTime;
			ar >> m_pDoc->m_nGoteTime;
			ar >> m_pDoc->m_nDefaultCounter;
			ar >> m_pDoc->m_bCountUp;
		}

		// f[^M
		case MSG_DATA:
		case MSG_GAME_END:
		{
			DWORD dwData;
			ar >> dwData;
			m_pDoc->m_koma.SetWord(HIWORD(dwData),LOWORD(dwData));
			m_pDoc->WriteRecord(HIWORD(dwData));

			ar >> m_pDoc->m_nSenteTime;
			ar >> m_pDoc->m_nGoteTime;
			break;
		}
		
		// SĎM
		case MSG_KIFUDATA:
		{
			m_pDoc->m_koma.Serialize(ar);
			int nCount;
			DWORD dwData;
			m_pDoc->Init();
			m_pDoc->m_pKifu->RemoveAll();
			ar >> nCount;
			for(int ii = 0; ii < nCount;ii++)
			{
				ar >> dwData;
				m_pDoc->m_koma.SetWord(HIWORD(dwData),LOWORD(dwData));
				m_pDoc->WriteRecord(HIWORD(dwData));
			}
			ar >> m_pDoc->m_szEnemyName;
			break;
		}

		// ڑvM
		case MSG_CONNECT:
		{
			ar >> m_pDoc->m_szEnemyName;
			break;
		}
		
		// [M
		case MSG_MAIL:
		{
			ar >> m_pDoc->m_szMailString;
			break;
		}

		// f[^M
		case MSG_GALLARY_KIFUDATA:
		{
			m_pDoc->m_koma.Serialize(ar);
			int nCount;
			DWORD dwData;
			m_pDoc->Init();
			m_pDoc->m_pKifu->RemoveAll();
			ar >> nCount;
			for(int ii = 0; ii < nCount;ii++)
			{
				ar >> dwData;
				m_pDoc->m_koma.SetWord(HIWORD(dwData),LOWORD(dwData));
				m_pDoc->WriteRecord(HIWORD(dwData));
			}
			ar >> m_pDoc->m_szSenteName;
			ar >> m_pDoc->m_szGoteName;
			CNSView* pView = m_pDoc->GetSDIView();
			if( pView != NULL )
				pView->UpdateKifuBar();
			break;
		}
		
		// M[̎Af[^M
		case MSG_GALLARY_DATA:
		{
			DWORD dwData;
			ar >> dwData;
			m_pDoc->m_koma.SetWord(HIWORD(dwData),LOWORD(dwData));
			m_pDoc->WriteRecord(HIWORD(dwData));
			break;
		}
		case MSG_GALLARY_CONNECT:
		{
			// M[ϐv
			ar >> m_pDoc->m_szWatcherName;
			break;
		}

		default:
		{
			break;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////
// CMsg diagnostics

#ifdef _DEBUG
void CMsg::AssertValid() const
{
	CObject::AssertValid();
}

void CMsg::Dump(CDumpContext& dc) const
{
	CObject::Dump(dc);
}
#endif //_DEBUG
